summaryrefslogtreecommitdiffstats
path: root/src/grep/tests/repetition-overflow
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-11 08:21:29 +0000
committerDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-11 08:21:29 +0000
commit29cd838eab01ed7110f3ccb2e8c6a35c8a31dbcc (patch)
tree63ef546b10a81d461e5cf5ed9e98a68cd7dee1aa /src/grep/tests/repetition-overflow
parentInitial commit. (diff)
downloadkbuild-29cd838eab01ed7110f3ccb2e8c6a35c8a31dbcc.tar.xz
kbuild-29cd838eab01ed7110f3ccb2e8c6a35c8a31dbcc.zip
Adding upstream version 1:0.1.9998svn3589+dfsg.upstream/1%0.1.9998svn3589+dfsg
Signed-off-by: Daniel Baumann <daniel.baumann@progress-linux.org>
Diffstat (limited to 'src/grep/tests/repetition-overflow')
-rwxr-xr-xsrc/grep/tests/repetition-overflow19
1 files changed, 19 insertions, 0 deletions
diff --git a/src/grep/tests/repetition-overflow b/src/grep/tests/repetition-overflow
new file mode 100755
index 0000000..38a652d
--- /dev/null
+++ b/src/grep/tests/repetition-overflow
@@ -0,0 +1,19 @@
+#!/bin/sh
+# These would fail (i.e., match erroneously) prior to grep-2.11.
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+
+xp1=4294967297 # 2^32+1
+xp2=4294967298 # 2^32+2
+
+fail=0
+
+# Before grep-2.11, when DFA-matching, a repetition count exceeding the
+# range of "unsigned int" would silently wrap around. Hence, 2^32+1
+# would be treated just like "1", and both of these would mistakenly match.
+
+echo abc | returns_ 2 grep -E "b{$xp1}" > out 2> /dev/null || fail=1
+compare /dev/null out || fail=1
+echo abbc | returns_ 2 grep -E "b{1,$xp2}" > out 2> /dev/null || fail=1
+compare /dev/null out || fail=1
+
+Exit $fail